//
//  mdlResponseType.swift
//
//
//  Created by Michiel Carman on 1/24/24.
//

import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlResponseType: Model, Content {
    static let schema = "responseType"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    
    @Field(key: "name") var name: String?
    @Field(key: "color") var color: String?
    @Field(key: "isActive") var isactive: Bool?
    
    @Parent(key: "repairTypeId") var repairtype: mdlRepairType
    @Children(for: \.$responsetype) var responses: [mdlInspectionItemResponse]
    
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init() { }
    
    init(id: Int? = nil, name: String? = nil, color: String? = nil, isactive: Bool? = nil, repairtypeid: Int, createuserid: Int? = nil, updateuserid: Int? = nil) {
        self.id = id
        
        self.name = name
        self.color = color
        self.isactive = isactive
        self.$repairtype.$id.value = repairtypeid
        
        self.createuserid = createuserid
        self.updateuserid = updateuserid
    }
}

extension mdlResponseType{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("responseType")
                .field("id", .int, .identifier(auto: true))
                .field("name", .string)
                .field("color", .string)
                .field("isActive", .bool)
                .field("responseTypeId", .int)
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }

        func revert(on database: Database) async throws {
            try await database.schema("responseType").delete()
        }
    }
    struct Mod1: AsyncMigration{
        func prepare(on database: Database) async throws {
            try await database.schema("responseType")
                .field("repairTypeId", .int, .references("repairType", "id"))
                .deleteField("responseTypeId")
                .update()
        }

        func revert(on database: Database) async throws {
            try await database.schema("responseType")
                .field("responseTypeId", .int)
                .deleteField("repairTypeId")
                .update()
        }
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlResponseType>{
        
        let query = mdlResponseType.query(on: req.db)
            .with(\.$repairtype)
            .with(\.$responses)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}



